/// <reference types="node" />
import { AugmentedRequest, RESTDataSource } from '@apollo/datasource-rest';
import type { KeyValueCache } from '@apollo/utils.keyvaluecache';
import { AccessInfo } from '../auth';
export declare enum HTTPVerb {
    GET = 0,
    POST = 1,
    PUT = 2,
    PATCH = 3,
    DELETE = 4
}
export declare abstract class BaseRESTDataSource extends RESTDataSource {
    protected readonly token: string;
    protected cache: KeyValueCache;
    baseURL: string;
    constructor(options: {
        token: string;
        cache?: KeyValueCache;
    });
    willSendRequest(_path: string, request: AugmentedRequest): void;
    resolveURL(path: string, _request: AugmentedRequest): Promise<import("url").URL>;
    protected invokeGraphqlWithCache(functionName: string, body: object, accessInfo?: AccessInfo, allowCache?: boolean, ttlSeconds?: number): Promise<any>;
    private invokeGraphql;
    protected invokeRestWithCache(functionName: string, path: string, body: object, accessInfo?: AccessInfo, allowCache?: boolean, ttlSeconds?: number): Promise<any>;
    private invokeRest;
    protected invokeExternalRestPost(functionName: string, path: string, body: object): Promise<any>;
    protected invokeExternalRestGet(functionName: string, path: string): Promise<any>;
}
